История версий БД
   База данных имеет свою версию, которая хранится в websettings.s_version
   а) БД считается "актуальной" если первые 3 числа ее версии сопадают с теми-же числами версии пакета.
      Это означает что приложения работают в полнофункциональном режиме.
   б) БД считается "допустимой" если первое и второе число сопадают с теми-же числами версии пакета.
      Это означает что приложения могут работать, но некоторые функции будут недоступны.
   в) БД считается "тестовой", если второе и третье число равны 9.
      Может быть использовано в целях разработки, тестов и т.д.

   1.9.9 - первая тестовая версия
   2.9.9 - добавлено применение модулей sysinfo
           CREATE TABLE `sysinfo` (
             `s_proxy_id` INT              NOT NULL ,
             `s_name`     VARCHAR( 50 )    NOT NULL ,
             `s_version`  VARCHAR( 10 )    NOT NULL ,
             `s_author`   VARCHAR( 30 )        NULL DEFAULT 'anonymous',
             `s_info`     VARCHAR( 1024 )  NOT NULL DEFAULT 'not available',
             `s_date`     DATETIME         NOT NULL ,
             `s_status`   INT              NOT NULL
           ) ENGINE = MYISAM;
           UPDATE websettings SET s_version='2.9.9';
   3.9.9 - добавлена функция перенаправления
           ALTER TABLE `redirect` ADD `s_dest` VARCHAR( 128 ) NULL ;
   4.9.9 - добавлена функция перевода пользователя в другой шаблон при превышении лимита
           ALTER TABLE `shablon` ADD `s_shablon_id2` BIGINT( 20 ) UNSIGNED NULL ;

081116
  Вторичный шаблон пользователя, баннерорезка, добавление комментариев,
  оптимизация работы с группами url адресов
  багфиксы: 
  1) в движке MySQL если числовое значение в БД равно NULL, вылетали демоны
  2) при перечитывании настроек список плагинов системной информации не очищался
081125
  Отправка письма администратору при блокировке пользователя (или переводе во временный шаблон)
081128
  Принимаются во внимание 2 параметра прокси сервера: регистр букв в домене и имени пользователя.
081129
  1) Перевод описания таблиц из формата doc в формат html с частичной проверкой актуальности.
  2) Документация по исходникам собирается и устанавливается, если найден doxygen.
     Скорей всего rpm после этого компилироваться не будет.
081130
  Начало написания документации по установке, настройке и использованию.
081203
  Исправление ошибки выполнения make install на FreeBSD (find: unknown option -iwholename)
  Небольшое дополнение документации
  Документация по исходникам теперь не собирается по умолчанию, для сборки необходимо указать
    опцию --with-srcdocs во время configure
081205
  Учитывается proxy.s_usedomain при создании acl, поиске и создании пользователей.
  Исправлена ошибка при создании БД. Не учитывалось что изменилась таблица shablon.
  Дополнение документации.
081207
  При автоматическом создании пользователя, он не вносился в squid.conf до следующего реконфигурирования.
  Не создавалась таблица sysinfo.
  Обновлена документация.
  Исправлены мелкие ошибки при создании пакета для RedHat.
081209
  Удаление линка wbinfo из репозитария, т.к. более не используется и вносит смуту при построении пакетов.
  Параметры proxy.s_bigd, proxy.s_bigu и proxy.s_squidbase теперь корректно отображаются в web и обновляются в БД.
081217
  Добавлена информация, выводимая на экран, в конце этапа configure.
  Корректная работа команды make uninstall
  Обновление документации (раздел требований)
  Fixed #78
081220
  Исправлена и расширена настройка авторизации OpenLDAP и загрузка пользователей. Требует доработки.
090328
  Доделан механизм регистрации/разрегистрации и автоматического удаления классов типа DBquery.
090329
  Счетчики пользователей после окончания периода ограничения очищаются только если в настройках прокси
  установлен флаг "Автоматически очищать счетчики трафика пользователей"
090407
  В samsdaemon и samsredir учитывается уровень отладочных сообщений, установленный в БД, но только если он
  не был явно задан из командной строки. При нестандартном периоде ограничения трафика в шаблоне, обновляется
  дата следующей очистки, но пока только в оперативной памяти (в БД не изменяется). Незначительное обновление
  документации.
090418
  Иправлена ошибка в определении IP адреса по доменному имени.
  Исправлена несвоевременная разрегистрация MYSQLQuery.
  Добавлено использование внутреннего кеша DNS ответов
090419
  Дата следующей очистки счетчиков у шаблонов с нестандартным периодом теперь обновляется в БД.
  Исправлена регистрация/разрегистрация PgQuery.
  Обновлена документация исходных кодов.
090425
  Обновлена документация исходных кодов. Добавлено описание отличий версии 1 и 2.
090428
  Оптимизирован поиск пользователей. Отключен кеш DNS ответов (необходимо использование TTL ответов)
090429
  Немного подправлено построение rpm пакетов.
090502
  Исправлено отображение статуса пользователя и ограничение трафика в веб интерфейсе.
  При удалении временного интервала в шаблоне теперь не переходит на редактирование другого шаблона.
  Правильно устанавливается значение "Запрет доступа ко всем url" при редактировании шаблона.
090503
  Период лимита шаблона 1 день.
  Правильно устанавливается значение уровня отладочных сообщений при редактировании прокси.
  Добавлено управление системными плагинами. Чтобы заработало, необходимо модифицировать БД.
  TRUNCATE TABLE sysinfo;
  ALTER TABLE  sysinfo ADD s_row_id SERIAL PRIMARY KEY FIRST;
090504
  Добавлена поддержка ограничения по расширениям файлов (пока только для редиректора)
  Теперь в разделы acl и http_access в squid.conf ничего не пишется, если используется встроенный редиректор.
090506
  Исправлена LDAP авторизация пользователя в веб интерфейсе
090507
  Исправлен импорт пользователей из LDAP
  Исправлено редактирование списков регулярных выражений.
  Теперь принимается и частичное совпадение url с регулярным выражением
090511
  Значительно переделан интерфейс редактирования настроек прокси сервера.
  Добавлена возможность редактирования списка подстановки запросов и подключение его к шаблону.
  Добавлена возможность указания вторичного шаблона.
090519
  Поддержка вторичных групп при импорте пользователей из LDAP
090528
  Блокировка пользователей в squid.conf только если никакой редиректор не используется.
090529
  В squid.conf правила для ip и host авторизации размещать ранее других.
090530
  Теперь не вызывается ф-ия получения данных системного плагина, если он не активен.
  Исправлено отображение пользователей при тестировании настроек ldap.
  Исправлен неавторизованный доступ администратором.
090602
  При использовании редиректора acl для блокированных пользователей на вносился в squid.conf,
  и, как следствие, squid не пускал такого пользователя никуда.
  Исправлен #362
  Исправлен #359
090607
  Применен патч для ntlm авторизации (предоставлен DogEater)
  Пересмотрена обработка списков доступа к ресурсам (в редиректоре)
  Обновлена документация.
090615
  Исправлен #370
090621
  Можно поставить статус пользователя "во временном шаблоне"
  Если пользователь во временном шаблоне, то в списке пользователей показывается лимит
  временного шаблона и выделяется желтым цветом.
  В информации пользователя использованный трафик показывается в форматированном виде.
  Заменены иконки статуса пользователя.
090624
  Исправлена компиляция плагина fsusage в FreeBSD (проверено на 7.2)
090625
  Исправлена ошибка формирования группы url адресов.
  При встроенном редиректоре шаблон с одним отключенным пользователем
  не прописывался в раздел http_access.
090703
  Добавлена прямая поддержка LDAP для проверки существования пользователя.
090914
  Пользователи с индивидуальным лимитом не попадали во вторичный шаблон.
  Запрет вывода пароля для подключения к LDAP.
  Слегка обновлена документация
090918
  Добавлены отладочные сообщения.
  При определении типа авторизации теперь не учитывается регистр.
090925
  Исправлена остановка демона из командной строки при использовании PgSQL.
  При сборке rpm пакета в документацию не попадали некоторые файлы.
  В документации добавлен раздел "Списки доступа".
090927
  Добавлено определение запретов в squid.conf по расширению файла и регулярным выражениям.
091006
  Добавлено использование шейпера. Изменена структура БД.
  CREATE TABLE delaypool (s_pool_id SERIAL PRIMARY KEY, s_name varchar(50), s_class int NOT NULL,
    s_agg1 int NOT NULL default '-1', s_agg2 int NOT NULL default '-1',
    s_net1 int NOT NULL default '-1', s_net2 int NOT NULL default '-1',
    s_ind1 int NOT NULL default '-1', s_ind2 int NOT NULL default '-1');
  CREATE TABLE d_link_s (s_pool_id int NOT NULL, s_shablon_id int NOT NULL, s_negative int);
  CREATE TABLE d_link_t (s_pool_id int NOT NULL, s_trange_id int NOT NULL, s_negative int);
  CREATE TABLE d_link_r (s_pool_id int NOT NULL, s_redirect_id int NOT NULL, s_negative int);
091008
  Удалены из таблицы shablon поля shablonpool и userpool.
  Удалено редактирование этих полей в веб интерфейсе.
  Обновлен скрипт импорта из sams 1.x (перенос пулов) 
091009
  Увеличена размерность поля s_name в таблицах shablon, timerange, redirect
091029
  Параметр deny_info в squid.conf не изменяется даже если присутствует подстрока Sams2
  Добавлено добавление/удаление редиректора в squid.conf
091030
  Fixed #391
091102
  Fixed #392
091102
  Добавлено распознавание TCP_SWAPFAIL_MISS в ответе squid.
  Исправлено поведение samsdaemon при неожиданном пропадании связи с MySQL
091105
  Изменен класс таблиц в системных плагинах.
  Исправлена небольшая утечка памяти в samsdaemon.
  Добавление некоторых сообщений в samslog.
  Исправлена ошибка при плановом переподключении к БД.
091106
  При нескольких одинаковых запросов samsdaemon'у он выполнял их несколько раз.
  При использовании PostgreSQL появлялись дублирующиеся пользователи.
  При загрузке логов с помощью samsparser проверяется попадает ли запись в текущий диапазон времени у шаблона,
  и если не попадает, то счетчики пользователя не обновляются.
091111
  Добавлен разделитель домена и пользователя при создании хеша пользователя, иначе не соблюдается уникальность хеша.
091112
  Добавлено описание Delay Pools в документации
091216
  Fixed #376
  Для решения проблемы в #396 нужно установить client_encoding в файле postgresql.conf в нужную кодировку.
  "Нужная" кодировка - та, которая используется в access.log у squid.
  На данный момент по умолчанию у клиента используется кодировка, совпадающая с кодировкой базы данных, т.е. UTF8
  (проверить можно командой psql -U $DB_USER -l, где $DB_USER - значение параметра из sams2.conf)
  Список кодировок, поддерживающих русский язык:
  ISO_8859_5, KOI8R, SQL_ASCII (т.е. "как есть", не рекомендуется), UTF8, WIN866, WIN1251
100226
  Не заносить в БД строки из access.log, если размер url равен 0. (Например, как у метода CONNECT)
  При отсутствии редиректора правильно формировать строку http_access в squid.conf, если у шаблона нет никаких ограничений.
